--[[
	Megadott szm vletlen szmot generlunk, majd
	egy output fjlba kirjuk ket a generls sorrendjben.
]]

-- Az ugyanebben a knyvtrban lv "anim.lua" nev
-- fjlt importljuk.
require("anim")

-- Az os.time() msodperc pontossg, de most megfelel
-- seednek.
math.randomseed(os.time())

-- Megadott szm vletlen szmmmal tlti fel a
-- kapott tmbt.
generate =
	function(a, itemcount)
		for i = 1, itemcount do
			a[i] = math.random(10000)
			coroutine.yield(i / itemcount)
		end

		return 1
	end

-- Kirja a megadott fjlba a kapott tmbt, az elemek
-- szmval kezdve.
write_to_file =
	function(f, a)
		f:write(#a.."\n")
		for i = 1, #a do
			f:write(a[i].." ")
			coroutine.yield(i / #a)
		end

		return 1
	end

-- A parancssori argumentumokra arg[n]-nel hivatkozhatunk,
-- 1-tl indexelve. Amire nem kaptunk rtket, az egy
-- alaprtelmezettet vesz fel.
itemcount = arg[1] or 1000000
filename = arg[2] or "lua_testdata"

a = {}

print("Generating numbers...")
-- Progress barral hvjuk a szmok generlct,
-- 0.1 msodperces frisstsi idkzzel.
anim.exec_animated(0.1, generate, a, itemcount)

-- Fjl megnyitsa rsra.
f = io.open(filename, "w")

print("Writing to file...")
-- Fjlba rs progress barral.
anim.exec_animated(0.1, write_to_file, f, a)


f:close()
